/* $Author: jkcohen $
 * $Source: /mnt1/h/jkcohen/Source/C/Hoc/RCS/math.c,v $
 * $Revision: 1.1 $ ; $Date: 87/03/16 21:18:20 $
 * $State: Stab $
*/

#include "su.h"
#include "jc.h"

extern int	errno;
double errcheck();

double Sqrt(x)
double x;
Begin
	Return errcheck(sqrt(x), "sqrt");
End

double Tan(x)
double x;
Begin
	Return errcheck(tan(x), "tan");
End

double Asin(x)
double x;
Begin
	Return errcheck(asin(x), "asin");
End

double Acos(x)
double x;
Begin
	Return errcheck(acos(x), "acos");
End

double Atan2(x, y)
double x, y;
Begin
	Return errcheck(atan2(x, y), "atan2");
End

double Exp(x)
double x;
Begin
	Return errcheck(exp(x), "exp");
End

double Log(x)
double x;
Begin
	Return errcheck(log(x), "log");
End

double Log10(x)
double x;
Begin
	Return errcheck(log10(x), "log10");
End

double Pow(x, y)
double x, y;
Begin
	Return errcheck(pow(x, y), "exponentiation");
End

double Sinh(x)
double x;
Begin
	Return errcheck(sinh(x), "sinh");
End

double Cosh(x)
double x;
Begin
	Return errcheck(cosh(x), "cosh");
End

double Gamma(x)
double x;
Begin
	Return errcheck(gamma(x), "gamma");
End
double Jn(n, x)
double n, x;
Begin
	Return errcheck(jn((int) n, x), "jn");
End


double Y0(x)
double x;
Begin
	Return errcheck(y0(x), "y0");
End

double Y1(x)
double x;
Begin
	Return errcheck(y1(x), "y1");
End

double Yn(n, x)
double n, x;
Begin
	Return errcheck(yn((int) n, x), "yn");
End

double Srand(x)
double x;
Begin
	Return (double) srand((int) x);
End

double Rand()
Begin
	Return (double) rand();
End

double integer(x)
double x;
Begin
	Return (double) (long) x;
End


double errcheck(d, s)	/* check result of library call */
double d;
char *s;

Begin
	If errno == EDOM Do
		errno = 0;
		execerror(s, "argument out of domain");
	Elseif errno == ERANGE Do
		errno = 0;
		execerror(s, "result out of range");
	Endif
	Return d;
End
