%token VOID AUTO STATIC EXTERN REGISTER TYPEDEF CHAR FLOAT
%token DOUBLE INT SHORT LONG UNSIGNED STRUCT UNIONkwd ENUM IF
%token ELSE WHILE DO FOR SWITCH BREAK CONTINUE RETURN GOTO
%token CASE DEFAULT SIZEOF
%token IDENTIFIER TYPEDEF_NAME /* Note: these are lexically identical! */
%token DEC_INT OCT_INT HEX_INT FLOAT_LIT CHAR_LIT STRING

%token ARROW   /* ->  */   PLUSPLUS /* ++  */	MINUSMINUS  /* -- */
%token LSHIFT  /* <<  */   RSHIFT   /* >>  */	LE	    /* <= */
%token GE      /* >=  */   EQEQ     /* ==  */	NE	    /* != */
%token ANDAND  /* &&  */   OROR     /* ||  */	PLUSEQ	    /* += */
%token RSHFTEQ /* >>= */   LSHFTEQ  /* <<= */	MINUSEQ     /* -= */
%token ANDEQ   /* &=  */   EOREQ    /* ^=  */	MULTEQ	    /* *= */
%token DIVEQ   /* /=  */   MODEQ    /* %=  */	OREQ	    /* |= */


%%

/*
 * The following LALR(1) description of C is cribbed from "C: A reference
 * Manual" by Harbison & Steele. It is uploaded to Compuserve, with the kind
 * permission of Samuel Harbison, by Ralph Dratman, CIS 74146,3275.
 * The symbols p1, p2, etc., are used to represent machine-generated 
 * symbols such as <0001>, <0002>, etc., from the grammar in H&S.
 * Unfortunately there are a few errors in the grammer as given in the book.
 * Some of these were obvious; others were not. But it all seems to work now.
 */

goal			:	program
			;

p1			:
			|	p1  top_level_decl
			;

program 		:	p1
			;

top_level_decl		:	top_level_data_decl
			|	top_level_function_decl
			;

top_level_data_decl	:	opt_decl_specifier  ';'
			|	opt_decl_specifier  list_init_dcltr  ';'
			;

p2			:
			|	p2  parameter_decl
			;

top_level_function_decl :	opt_decl_specifier  dcltr  p2  compound_stmt
			;

local_data_decl 	:	decl_specifier	';'
			|	decl_specifier	list_init_dcltr  ';'
			;

parameter_decl		:	decl_specifier	';'
			|	decl_specifier	list_dcltr  ';'
			;

typename_decl		:	decl_specifier	abs_dcltr
			;

p3			:
			|	p3  struct_decl
			;

list_struct_decl	:	p3
			;

p4			:	formal_decl
			|	p4  ','  formal_decl
			;

formals_decl		:
			|	p4
			;

formal_decl		:	opt_decl_specifier  dcltr
			;

opt_decl_specifier	:
			|	decl_specifier
			;

p5			:	tc_specifier
			|	p5  tc_specifier
			;

decl_specifier		:	p5
			;

tc_specifier		:	std_class
			|	type_specifier
			;

std_class		:	AUTO
			|	STATIC
			|	EXTERN
			|	REGISTER
			|	TYPEDEF
			;

type_specifier		:	TYPEDEF_NAME
			|	std_type
			|	struct_specifier
			|	enum_specifier
			;

std_type		:	CHAR
			|	FLOAT
			|	DOUBLE
			|	INT
			|	SHORT
			|	LONG
			|	UNSIGNED
			|	VOID
			;

struct_specifier	:	struct_ctype  struct_name
			|	union_ctype  union_name
			|	struct_ctype
				'{'  list_struct_decl  '}'
			|	struct_ctype  str_tag_dcltr
				'{'  list_struct_decl  '}'
			|	union_ctype
				'{'  list_struct_decl  '}'
			|	union_ctype  un_tag_dcltr
				'{'  list_struct_decl  '}'
			;

struct_ctype		:	STRUCT
			;

union_ctype		:	UNIONkwd
			;

struct_decl		:	decl_specifier	list_struct_dcltr  ';'
			;

struct_dcltr		:	dcltr
			|	':'  exp
			|	dcltr  ':'  exp
			;

p6			:	enum_dcltr
			|	p6  ','  enum_dcltr

p7			:	'{'  p6  '}'
			|	'{'  p6  ','  '}'
			;

enum_specifier		:	enum_ctype  enum_name
			|	enum_ctype  p7
			|	enum_ctype  en_tag_dcltr  p7
			;

enum_ctype		:	ENUM
			;

enum_dcltr		:	name_dcltr
			|	name_dcltr  '='  exp
			;

name_dcltr		:	IDENTIFIER
			;

str_tag_dcltr		:	IDENTIFIER
			;

un_tag_dcltr		:	IDENTIFIER
			;

en_tag_dcltr		:	IDENTIFIER
			;

/* The first "orphan" rule (not contributing to the parse goal).....
key_dcltr		:	IDENTIFIER
			;
..................................................................*/

p1_dcltr		:	name_dcltr
			|	'('  dcltr  ')'
			;

p2_dcltr		:	p1_dcltr
			|	p2_dcltr  '('  formals_decl  ')'
			|	p2_dcltr  '['  ']'
			|	p2_dcltr  '['  list_exp  ']'
			;

/* The other "orphan" rule. Where did they come from? .......
p8			:	key_dcltr
			|	p8  ','  key_dcltr
			;
...........................................................*/

p3_dcltr		:	p2_dcltr
			|	'*'  p3_dcltr
			;

dcltr			:	p3_dcltr
			;

init_dcltr		:	dcltr
			|	dcltr  '='  init_exp
			;

p9			:	init_exp
			|	p9  ','  init_exp
			;

init_exp		:	exp
			|	'{'  p9  '}'
			|	'{'  p9  ','  '}'
			;

p1_abs_dcltr		:	'('  p3_abs_dcltr  ')'
			;

p2_abs_dcltr		:	p1_abs_dcltr
			|	p2_abs_dcltr  '('  ')'
			|	'(' ')'
			|	p2_abs_dcltr  '['  ']'
			|	p2_abs_dcltr  '['  list_exp  ']'
			|	e_abs_dcltr   '['  ']'
			|	e_abs_dcltr   '['  list_exp  ']'
			;

p3_abs_dcltr		:	p2_abs_dcltr
			|	'*'  p3_abs_dcltr
			|	'*'  e_abs_dcltr
			;

e_abs_dcltr		:	/* huh? */
			;

abs_dcltr		:	p3_abs_dcltr
			|	e_abs_dcltr
			;

p10			:	init_dcltr
			|	p10  ','  init_dcltr
			;

list_init_dcltr 	:	p10
			;

p11			:	struct_dcltr
			|	p11  ','  struct_dcltr
			;

list_struct_dcltr	:	p11
			;

p12			:	dcltr
			|	p12  ','  dcltr
			;

list_dcltr		:	p12
			;

p13			:
			|	p13  decl_or_stmt
			;

compound_stmt		:	'{'  p13  '}'
			;

decl_or_stmt		:	local_data_decl
			|	stmt
			;

basic_stmt		:	e_stmt
			|	compound_stmt
			|	do_stmt
			|	break_stmt
			|	continue_stmt
			|	return_stmt
			|	goto_stmt
			|	null_stmt
			;

bal_stmt		:	basic_stmt
			|	bal_while_stmt
			|	bal_for_stmt
			|	bal_ifelse_stmt
			|	bal_switch_stmt
			|	label  bal_stmt
			;

unbal_stmt		:	unbal_while_stmt
			|	unbal_for_stmt
			|	unbal_if_stmt
			|	unbal_ifelse_stmt
			|	unbal_switch_stmt
			|	label  unbal_stmt
			;

bal_ifelse_stmt 	:	IF  '('  list_exp  ')'
					bal_stmt
				ELSE
					bal_stmt
			;

unbal_ifelse_stmt	:	IF  '('  list_exp  ')'
					bal_stmt
				ELSE
					unbal_stmt
			;

unbal_if_stmt		:	IF  '('  list_exp  ')'
					stmt
			;

stmt			:	bal_stmt
			|	unbal_stmt
			;

e_stmt			:	list_exp  ';'
			;

bal_while_stmt		:	WHILE  '('  list_exp  ')'
					bal_stmt
			;

unbal_while_stmt	:	WHILE  '('  list_exp  ')'
					unbal_stmt
			;

do_stmt 		:	DO  stmt  WHILE  '('  list_exp	')'  ';'
			;

p14			:	';'  ')'  bal_stmt
			|	';'  list_exp  ')'  bal_stmt
			;

p15			:	';'  p14
			|	';'  list_exp  p14
			;

bal_for_stmt		:	FOR  '('  p15
			|	FOR  '('  list_exp  p15
			;

p16			:	';'  ')'  unbal_stmt
			|	';'  list_exp  ')'  unbal_stmt
			;

p17			:	';'  p16
			|	';'  list_exp  p16
			;

unbal_for_stmt		:	FOR  '('  p17
			|	FOR  '('  list_exp  p17
			;

bal_switch_stmt 	:	SWITCH	'('  list_exp  ')'
					bal_stmt
			;

unbal_switch_stmt	:	SWITCH	'('  list_exp  ')'
					unbal_stmt
			;

break_stmt		:	BREAK  ';'
			;

continue_stmt		:	CONTINUE  ';'
			;

return_stmt		:	RETURN	';'
			|	RETURN	list_exp  ';'
			;

goto_stmt		:	GOTO  label_name  ';'
			;

null_stmt		:	';'
			;

label			:	name_label
			|	case_label
			|	default_label
			;

name_label		:	IDENTIFIER  ':'
			;

case_label		:	CASE  exp  ':'
			;

default_label		:	DEFAULT  ':'
			;

literal 		:	DEC_INT
			|	OCT_INT
			|	HEX_INT
			|	FLOAT_LIT
			|	CHAR_LIT	/* note name change */
			|	STRING
			;

id_name 		:	IDENTIFIER
			;

struct_name		:	IDENTIFIER
			;

union_name		:	IDENTIFIER
			;

enum_name		:	IDENTIFIER
			;

label_name		:	IDENTIFIER
			;

field_name		:	IDENTIFIER
			;

paren_exp		:	'('  list_exp  ')'
			;

primary_p1_exp		:	id_name
			|	literal
			|	paren_exp
			|	SIZEOF	'('  typename_decl  ')'
			;

primary_p2_exp		:	primary_p1_exp
			|	primary_p2_exp	'['  list_exp  ']'
			|	primary_p2_exp	'('  ')'
			|	primary_p2_exp	'('  list_exp  ')'
			|	primary_p2_exp	'.'  field_name
			|	primary_p2_exp	ARROW  field_name
			;

primary_exp		:	primary_p2_exp
			;

postfix_exp		:	primary_exp
			|	postfix_exp  postfix_op
			;

postfix_op		:	PLUSPLUS
			|	MINUSMINUS
			;

prefix_exp		:	postfix_exp
			|	SIZEOF	prefix_exp
			|	prefix_op  cast_exp
			|	'*'  cast_exp
			|	'&'  cast_exp
			|	negate_op  cast_exp
			;

prefix_op		:	PLUSPLUS
			|	MINUSMINUS
			;

negate_op		:	'-'
			|	'!'
			|	'~'
			;

cast_exp		:	prefix_exp
			|	'('  typename_decl  ')'  prefix_exp
			;

unary_oper_exp		:	cast_exp
			;

mult_oper_exp		:	unary_oper_exp
			|	mult_oper_exp  mult_op	unary_oper_exp
			;

mult_op 		:	'*'
			|	'/'
			|	'%'
			;

add_oper_exp		:	mult_oper_exp
			|	add_oper_exp  add_op  mult_oper_exp
			;

add_op			:	'+'
			|	'-'
			;

shift_oper_exp		:	add_oper_exp
			|	shift_oper_exp	shift_op  add_oper_exp
			;

shift_op		:	LSHIFT		/* << */
			|	RSHIFT		/* >> */
			;

rel_oper_exp		:	shift_oper_exp
			|	rel_oper_exp  rel_op  shift_oper_exp
			;

rel_op			:	'<'
			|	LE		/* <= */
			|	GE		/* >= */
			|	'>'
			;

equ_oper_exp		:	rel_oper_exp
			|	equ_oper_exp  equ_op  rel_oper_exp
			;

equ_op			:	EQEQ		/* == */
			|	NE		/* != */
			;

bitand_oper_exp 	:	equ_oper_exp
			|	bitand_oper_exp  '&'  equ_oper_exp
			;

bitxor_oper_exp 	:	bitand_oper_exp
			|	bitxor_oper_exp  '^'  bitand_oper_exp
			;

bitor_oper_exp		:	bitxor_oper_exp
			|	bitor_oper_exp	'|'  bitxor_oper_exp
			;

and_oper_exp		:	bitor_oper_exp
			|	and_oper_exp  ANDAND  bitor_oper_exp
					     /* && */
			;

or_oper_exp		:	and_oper_exp
			|	or_oper_exp  OROR  and_oper_exp
					   /* || */
			;

cond_exp		:	or_oper_exp
			|	or_oper_exp  '?'  list_exp  ':'  cond_exp
			;

assign_exp		:	cond_exp
			|	cond_exp  asgn_op  exp
			;

asgn_op 		:	'='
			|	PLUSEQ		/*  +=	*/
			|	MINUSEQ 	/*  -=	*/
			|	MULTEQ		/*  *=	*/
			|	DIVEQ		/*  /=	*/
			|	MODEQ		/*  %=	*/
			|	RSHFTEQ 	/*  >>= */
			|	LSHFTEQ 	/*  <<= */
			|	ANDEQ		/*  &=	*/
			|	EOREQ		/*  ^=	*/
			|	OREQ		/*  |=	*/
			;

exp			:	assign_exp
			;

list_exp		:	exp
			|	list_exp  ','  exp
			;

%%
